dialog Lookup {
  title "Gamers Lookup"
  size -1 -1 168 240
  option dbu
  tab "Steam ID", 13, 0 0 171 240
  text "Choose Your Lookup Method", 5, 8 25 153 8, tab 13 center
  radio "SteamID", 1, 18 33 42 10, tab 13
  radio "Alias", 2, 66 33 42 10, tab 13
  radio "Name", 3, 114 33 42 10, tab 13
  radio "IRC Channel", 11, 114 45 42 10, tab 13
  radio "Tag", 10, 66 45 42 10, tab 13
  radio "Team", 9, 18 45 42 10, tab 13
  edit "", 4, 50 58 66 10, tab 13
  button "Search", 6, 4 74 53 12, tab 13
  edit "", 8, 10 90 146 130, tab 13 read multi return autovs hsbar vsbar
  button "Clear Search Results", 12, 48 224 77 12, tab 13
  text "Steam User Search", 23, 8 16 153 8, tab 13 center
  tab "ESEA", 14
  edit "", 15, 10 90 146 130, tab 14 read multi return autovs hsbar vsbar
  edit "", 16, 50 58 66 10, tab 14
  button "Search", 17, 4 74 53 12, tab 14
  button "Clear Search Results", 19, 48 224 77 12, tab 14
  button "Add To Buddy List", 20, 58 74 53 12, tab 14
  text "Enter User ID", 21, 50 48 66 10, tab 14 center
  text "ESEA User ID Search", 22, 8 16 153 8, tab 14 center
  tab "Got Frag", 7
  text "Got Frag User ID Search", 24, 8 16 153 8, tab 7 center
  text "Enter User ID", 25, 50 48 66 10, tab 7 center
  edit "", 26, 50 58 66 10, tab 7
  button "Add To Buddy List", 55, 58 74 53 12, tab 7
  button "Search", 27, 4 74 53 12, tab 7
  edit "", 28, 10 90 146 130, tab 7 read multi return autovs hsbar vsbar
  button "Clear Search Results", 29, 48 224 77 12, tab 7
  tab "Amped", 30
  text "Amped User ID Search", 31, 8 16 153 8, tab 30 center
  text "Enter User ID", 32, 50 48 66 10, tab 30 center
  edit "", 33, 50 58 66 10, tab 30
  button "Search", 34, 4 74 53 12, tab 30
  edit "", 35, 10 90 146 130, tab 30 read multi return autovs hsbar vsbar
  button "Clear Search Results", 36, 48 224 77 12, tab 30
  button "Close", 18, 112 74 53 12, cancel
}



alias lookup {
  dialog -m lookup lookup
}

on *:dialog:lookup:sclick:12: {
  did -r lookup 8
  did -r lookup 4
  did -u lookup 9
  did -u lookup 1
  did -u lookup 2
  did -u lookup 10
  did -u lookup 11
  did -u lookup 3
}


on *:dialog:lookup:sclick:6: {
  if ($did(4,1).len == 0) {
    did -a lookup 8 [ Please Enter Your Search ] $crlf $crlf | halt
  }
  else {
    if ($did(1).state > 0) {
      if ($did(4).text isletter) {
        did -a lookup 8 [ SteamID Must be a Number ] $crlf $crlf | halt 
      }
      else {
        set %steam.radio steamid
        set %steam.userid $did(4).text
        steam.user
        did -a lookup 8 [ Search Results For SteamID: " $+ %steam.userid $+ " ] $crlf $crlf 
        halt
      }
    }
    if ($did(9).state > 0) {
      set %steam.radio team
      set %steam.userid $did(4).text
      steam.user
      did -a lookup 8 [ Search Results For Team: " $+ %steam.userid $+ " ] $crlf $crlf 
      halt  
    }
    if ($did(2).state > 0) {
      set %steam.radio alias
      set %steam.userid $did(4).text
      steam.user
      did -a lookup 8 [ Search Results For Alias: " $+ %steam.userid $+ " ] $crlf $crlf 
      halt  
    }
    if ($did(3).state > 0) {
      set %steam.radio name
      set %steam.userid $did(4).text
      steam.user
      did -a lookup 8 [ Search Results For Name: " $+ %steam.userid $+ " ] $crlf $crlf 
      halt  
    }
    if ($did(11).state > 0) {
      set %steam.radio irc
      set %steam.userid $did(4).text
      steam.user
      did -a lookup 8 [ Search Results For IRC Channel: " $+ %steam.userid $+ " ] $crlf $crlf 
      halt  
    }
    if ($did(10).state > 0) {
      set %steam.radio tag
      set %steam.userid $did(4).text
      steam.user
      did -a lookup 8 [ Search Results For Tag: " $+ %steam.userid $+ " ] $crlf $crlf 
      halt  
    }
    else { 
      did -a lookup 8 [ Please Select a Lookup Method ] $crlf $crlf | halt 
    }
  }
}


alias steam.user {
  sockclose steam.user
  sockopen steam.user steamid.elite-pimps.com 80
}

on *:sockopen:steam.user:{
  sockwrite -n $sockname GET /index.php?action=search&type=single&key= $+ %steam.radio $+ &query= $+ $replace(%steam.userid,:,$chr(37) $+ 3A,$chr(32),+,$chr(35),$chr(37) $+ 23,],$chr(37) $+ 5D,[,$chr(37) $+ 5B,|,$chr(37) $+ 7C,=,$chr(37) $+ 3D,`,$chr(37) $+ 60,^,$chr(37) $+ 5E) $+ &output=xml&version=extended HTTP/1.1
  sockwrite -n $sockname Host: steamid.elite-pimps.com
  sockwrite -n $sockname Connection: close
  sockwrite -n $sockname $crlf
  set %wonid.total. [ $+ [ $sockname ] ] 0
}


;; [WonID] ------- Sockread event
on *:sockread:steam.user:{
  if ($sockerr > 0) return
  while ($sock($sockname)) {
    sockread %temp
    set -l %data $gettok($gettok(%temp,2,$asc(> )),1,$asc(< ))
    if ($sockbr == 0) return
    if (%temp == <disabled> ) {
      if ($left($gettok($sock($sockname).mark,2,32),1) == n) notice $right($gettok($sock($sockname).mark,2,32),-1) error. source db disabled contact script author.
      did -a lookup 8 error. source db disabled contact script author.
    }
    else if (%temp == </results> ) {
      if ($left($gettok($sock($sockname).mark,2,32),1) == n) did -a lookup 8 %wonid.total. [ $+ [ $sockname ] ] result $+ $iif(%wonid.total. [ $+ [ $sockname ] ] != 1,s) Found.
      else did -a lookup 8 [ $+ $chr(32) $+ %wonid.total. [ $+ [ $sockname ] ] Result $+ $iif(%wonid.total. [ $+ [ $sockname ] ] != 1,s) Found. ] $crlf $crlf       
      sockclose wonid. $+ $nick
    }
    else if (%temp == <result> ) inc %wonid.total. [ $+ [ $sockname ] ]
    else if (<ban_status>*</ban_status> iswm %temp) set %wonid.ban_status. [ $+ [ $sockname ] ] %data
    else if (<player_id>*</player_id> iswm %temp) set %wonid.player_id. [ $+ [ $sockname ] ] %data
    else if (<player_alias>*</player_alias> iswm %temp) set %wonid.player_alias. [ $+ [ $sockname ] ] %data
    else if (<player_name>*</player_name> iswm %temp) set %wonid.player_name. [ $+ [ $sockname ] ] %data
    else if (<player_wonid>*</player_wonid> iswm %temp) set %wonid.player_wonid. [ $+ [ $sockname ] ] %data
    else if (<team_id>*</team_id> iswm %temp) set %wonid.team_id. [ $+ [ $sockname ] ] %data
    else if (<team_game>*</team_game> iswm %temp) set %wonid.team_game. [ $+ [ $sockname ] ] %data
    else if (<team_league>*</team_league> iswm %temp) set %wonid.team_league. [ $+ [ $sockname ] ] %data
    else if (<team_division>*</team_division> iswm %temp) set %wonid.team_division. [ $+ [ $sockname ] ] %data
    else if (<team_location>*</team_location> iswm %temp) set %wonid.team_location. [ $+ [ $sockname ] ] %data
    else if (<team_name>*</team_name> iswm %temp) set %wonid.team_name. [ $+ [ $sockname ] ] %data
    else if (<team_tag>*</team_tag> iswm %temp) set %wonid.team_tag. [ $+ [ $sockname ] ] %data
    else if (<team_record>*</team_record> iswm %temp) set %wonid.team_record. [ $+ [ $sockname ] ] %data
    else if (<team_irc>*</team_irc> iswm %temp) set %wonid.team_irc. [ $+ [ $sockname ] ] %data
    else if (<team_website>*</team_website> iswm %temp) set %wonid.team_website. [ $+ [ $sockname ] ] %data
    else if (%temp == </result> ) {
      set %wonid.return. [ $+ [ $sockname ] ] [ $+ $chr(32) $+ SteamID: %wonid.player_wonid. [ $+ [ $sockname ] ] ] $crlf $+ [ Handle: %wonid.player_alias. [ $+ [ $sockname ] ] ] $crlf $+ [ Real Name: %wonid.player_name. [ $+ [ $sockname ] ]  ] $crlf  
      set %wonid.return.2. [ Team: %wonid.team_name. [ $+ [ $sockname ] ] ( $+ %wonid.team_tag. [ $+ [ $sockname ] ] $+ ) ] $crlf $+ [ League: %wonid.team_league. [ $+ [ $sockname ] ] $+ - $+ %wonid.team_division. [ $+ [ $sockname ] ] ] $crlf $+ [ Record: %wonid.team_record. [ $+ [ $sockname ] ] %wonid.splitter ] $crlf $+
      set %wonid.return.3. [ $+ $chr(32) $+ Location: %wonid.team_location. [ $+ [ $sockname ] ] ] $crlf $+ [ Website: %wonid.team_website. [ $+ [ $sockname ] ] ] $crlf $+ [ IRC: %wonid.team_irc. [ $+ [ $sockname ] ] ] $crlf $crlf
      if ($left($gettok($sock($sockname).mark,2,32),1) == n) notice $right($gettok($sock($sockname).mark,2,32),-1) %wonid.return
      else { 
        did -a lookup 8 %wonid.return. [ $+ [ $sockname ] ]
        did -a lookup 8 %wonid.return.2. 
        did -a lookup 8 %wonid.return.3.
      }
    }
  }
}


;====================================
;ESEA
;====================================



alias esea {
  dialog -m esea esea
}

alias -l htmlfree {
  var %x, %i = $regsub($1-,/(^[^<]*>|<[^>]*>|<[^>]*$)/g,$null,%x), %x = $remove(%x, )
  return %x
}

dialog esea {
  title "ESEA UserID Search"
  size -1 -1 200 175
  option dbu
  box "Enter UserID", 1, 70 15 50 20
  edit "", 6, 72 23 45 10
  edit "", 2, 20 45 160 100,multi autovs hsbar vsbar return read
  box "Returned Info", 5, 18 37 165 110
  button "Search", 3, 2 5 50 10
  button "Add to Buddy List", 7, 125 23 50 10
  button "Close", 4, 2 17 50 10,cancel
}

on *:dialog:lookup:sclick:19: {
  did -r lookup 15
  did -r lookup 16
}

on *:dialog:lookup:sclick:20: {
  if ($did(16).text !isnum) { did -a lookup 15 [ UserID Must be a Number ] $crlf $crlf | halt }
  else {
    set %esea.userid $did(16).text
    url http://esportsea.com/index.php?s=buddylist&d=xadd&id= $+ %esea.userid
  }
}
on *:dialog:lookup:sclick:17: {
  if ($did(16).text !isnum) { did -a lookup 15 [ UserID Must be a Number ] $crlf $crlf | halt }
  else {
    set %esea.userid $did(16).text
    esea.user
  }
}

alias esea.user {
  sockclose esea.user
  sockopen esea.user esportsea.com 80
}

on *:sockopen:esea.user:{
  sockwrite -n $sockname GET /? $+ %esea.userid HTTP/1.1
  sockwrite -n $sockname Host: www.esportsea.com
  sockwrite -n $sockname Connection: close
  sockwrite -n $sockname
}

on *:sockread:esea.user:{
  var %temp
  sockread %temp
  if (*Invalid user id* iswm %temp) { did -a lookup 15 [ Profile not found Invalid UserID ] $crlf $crlf | sockclose $sockname }
  if (*<th align="left" width="110">Name:</th>* iswm %temp) {
    sockread %temp
    sockread %temp
    sockread %temp
    set %esea.name $remove($htmlfree(%temp),$chr(9))
  }
  if (*Age:</th>* iswm %temp) {
    sockread %temp
    sockread %temp
    sockread %temp
    set %esea.age $remove($htmlfree(%temp),$chr(9))
  }
  if (*Sex:</th>* iswm %temp) {
    sockread %temp
    sockread %temp
    sockread %temp
    set %esea.sex $remove($htmlfree(%temp),$chr(9))
  }
  if (*Country:</th>* iswm %temp) {
    sockread %temp
    sockread %temp
    sockread %temp
    set %esea.country $remove($gettok(%temp,3,61),$chr(34),class,$chr(9))
  }
  if (*Status:</th>* iswm %temp) {
    sockread %temp
    sockread %temp    
    sockread %temp | sockread %temp | sockread %temp | sockread %temp
    set %esea.status $remove($htmlfree(%temp),$chr(9))
  }
  if (*Website:</th>* iswm %temp) {
    sockread %temp
    sockread %temp
    sockread %temp
    set %esea.website $remove($htmlfree(%temp),$chr(9))
  }
  if (*<a href="aim:goim?screenname=* iswm %temp) {
    set %esea.aim $remove($htmlfree(%temp),$chr(9))
  }
  if (*MSN Messenger:</th>* iswm %temp) {
    sockread %temp
    sockread %temp
    sockread %temp
    set %esea.msn $remove($htmlfree(%temp),$chr(9))
  }
  if (*align="left">Steam* iswm %temp) {
    sockread %temp
    sockread %temp
    sockread %temp
    set %esea.steam $remove($htmlfree(%temp),$chr(9))
  }
  if (*Frags:</th>* iswm %temp) {
    sockread %temp
    sockread %temp
    sockread %temp
    set %esea.frags $remove($htmlfree(%temp),$chr(9))
  }
  if (*Deaths:</th>* iswm %temp) {
    sockread %temp
    sockread %temp
    sockread %temp
    set %esea.deaths $remove($htmlfree(%temp),$chr(9))
  }
  if (*Hours:</th>* iswm %temp) {
    sockread %temp
    sockread %temp
    sockread %temp
    set %esea.hours $remove($htmlfree(%temp),$chr(9))
  }
  if (*Points:</th>* iswm %temp) {
    sockread %temp
    sockread %temp
    sockread %temp
    set %esea.points $remove($htmlfree(%temp),$chr(9))
  }
  if (*Currently Playing:</th>* iswm %temp) {
    sockread %temp
    sockread %temp
    sockread %temp | sockread %temp | sockread %temp | sockread %temp
    set %esea.playing $remove($htmlfree(%temp),$chr(9))
  }
  if (*Current Team:</th>* iswm %temp) {
    sockread %temp
    sockread %temp
    sockread %temp
    set %esea.team $remove($htmlfree(%temp),$chr(9)) 
  }
}

on *:sockclose:esea.user: {
  did -a lookup 15 [ E-Sports EA ] $crlf
  if (%esea.name != $null) { did -a lookup 15 [ Name: %esea.name ] $crlf }
  if (%esea.age != $null) { did -a lookup 15 [ Age: %esea.age ] $crlf }
  if (%esea.sex != $null) { did -a lookup 15 [ Sex: %esea.sex ] $crlf }
  if (%esea.country != $null) { did -a lookup 15 [ Country: %esea.country ] $crlf }
  if (%esea.status != $null) { did -a lookup 15 [ Status: %esea.status ] $crlf }
  if ((%esea.website != $null) && (%esea.website != http://)) { did -a lookup 15 [ Website: %esea.website ] $crlf }
  if (%esea.aim != $null) { did -a lookup 15 [ AIM ScreenName: %esea.aim ] $crlf }
  if (%esea.msn != $null) { did -a lookup 15 [ MSN Messenger: %esea.msn ] $crlf }
  if (%esea.steam != $null) { did -a lookup 15 [ Steam Name: %esea.steam ] $crlf }
  if (%esea.frags != $null) { did -a lookup 15 [ Frags: %esea.frags ] $crlf }
  if (%esea.deaths != $null) { did -a lookup 15 [ Deaths: %esea.deaths ] $crlf }
  if (%esea.hours != $null) { did -a lookup 15 [ Hours: %esea.hours ] $crlf }
  if (%esea.points != $null) { did -a lookup 15 [ Points: %esea.points ] $crlf }
  if (%esea.playing != $null) { did -a lookup 15 [ Currently Playing: %esea.playing ] $crlf }
  if (%esea.team != $null) { did -a lookup 15 [ Current Team: %esea.team ] $crlf }
  did -a lookup 15 $crlf
  unset %esea.*
}

;====================================
;gotfrag
;====================================

alias -l htmlfree {
  var %x, %i = $regsub($1-,/(^[^<]*>|<[^>]*>|<[^>]*$)/g,$null,%x), %x = $remove(%x, )
  return %x
}


on *:dialog:lookup:sclick:29: {
  did -r lookup 26
  did -r lookup 28
}

on *:dialog:lookup:sclick:27: {
  if ($did(26).text !isnum) { did -a lookup 28 [ UserID Must be a Number ] $crlf $crlf | halt }
  else {
    set %gotfrag.userid $did(26).text
    gotfrag.user
  }
}

on *:dialog:lookup:sclick:55: {
  if ($did(26).text !isnum) { did -a lookup 28 [ UserID Must be a Number ] $crlf $crlf | halt }
  else {
    set %gotfrag.userid $did(26).text
    url http://www.gotfrag.com/portal/user/buddyadd/ $+ %gotfrag.userid
  }
}


alias gotfrag.user {
  sockclose gotfrag.user
  sockopen gotfrag.user gotfrag.com 80
}

on *:sockopen:gotfrag.user:{
  sockwrite -n $sockname GET /portal/user/ $+ %gotfrag.userid HTTP/1.1
  sockwrite -n $sockname Host: www.gotfrag.com
  sockwrite -n $sockname Connection: close
  sockwrite -n $sockname
}

on *:sockread:gotfrag.user:{
  var %temp
  sockread %temp
  if (*The specified userid*does not exist* iswm %temp) { did -a lookup 28 [ Profile not found Invalid UserID ] $crlf $crlf | sockclose $sockname }
  if (User details</td> isin %temp) || (User Statistics</td> isin %temp) inc %gotfrag.capture
  elseif (%gotfrag.capture) {
    if (</table></td><td align='left' isin %temp) && (%gotfrag.capture >= 2) unset %gotfrag.capture
    %gotfrag.temp = %gotfrag.temp $htmlfree(%temp)
  }
}

on *:sockclose:gotfrag.user: {
  set %gotfrag.info2 $replace(%gotfrag.temp,handle:,[ Handle: $+ $chr(32),real name:, $+ $chr(32) $+ ] $crlf $+ [ Real Name: $+ $chr(32),country:, $+ $chr(32) $+ ] $crlf $+ [ Country: $+ $chr(32),Sex:, ] $crlf $+ [ Sex: $+ $chr(32),Age:, $+ $chr(32) $+ ] $crlf $+ [ Age: $+ $chr(32),IRC Hangout:, $+ $chr(32) $+ ] $crlf $+ [ IRC Hangout: $+ $chr(32),Account:, ] $crlf $+ [ Account: $+ $chr(32),Account ID:, ] $crlf $+ [ Account ID: $+ $chr(32),Account Type:, $+ $chr(32) $+ ] $crlf $+ [ Account Type: $+ $chr(32),Buddied By:, ] $crlf $+ [ Buddied By: $+ $chr(32),Comments Posted:, $+ $chr(32) $+ ] $crlf $+ [ Comments Posted: $+ $chr(32))
  set %gotfrag.info3 $replace(%gotfrag.info2,Demos uploaded:, $+ $chr(32) $+ ] $crlf $+ [ Demos Uploaded: $+ $chr(32),Forum Replies:,$chr(126),User Rating:,$chr(126) $+ $chr(32) $+ ] $crlf $+ [ User Rating: $+ $chr(32),last seen:,$chr(126))
  set %gotfrag.info4 $remove(%gotfrag.info3,$gettok(%gotfrag.info3,2,126),$gettok(%gotfrag.info3,4,126),$chr(126))
  set %gotfrag.info %gotfrag.info4 ] $crlf $crlf 
  did -a lookup 28 2 %gotfrag.info
  unset %gotfrag.*
}



;====================================
;amped
;====================================

on *:dialog:lookup:sclick:36: {
  did -r lookup 35
  did -r lookup 33
}

alias -l htmlfree {
  var %x, %i = $regsub($1-,/(^[^<]*>|<[^>]*>|<[^>]*$)/g,$null,%x), %x = $remove(%x, )
  return %x
}

dialog amped {
  title "AmpedNews UserID Search"
  size -1 -1 200 175
  option dbu
  box "Enter UserID", 1, 70 15 50 20
  edit "", 6, 72 23 45 10
  edit "", 2, 20 45 160 100,multi autovs hsbar vsbar return read
  box "Returned Info", 5, 18 37 165 110
  button "Search", 3, 2 5 50 10
  button "Close", 4, 2 17 50 10,cancel
}

on *:dialog:lookup:sclick:34: {
  set %amped.userid $did(33).text
  amped.user
}

alias amped.user {
  if ($sock(amped.user)) {
    sockclose amped.user
  }
  if (%amped.temp) {
    unset %amped.*
  }
  sockopen amped.user ampednews.com 80
}
on *:sockopen:amped.user:{
  sockwrite -n amped.user GET /?page=profile&id= $+ %amped.userid HTTP/1.1
  sockwrite -n amped.user Host: www.ampednews.com
  sockwrite -n amped.user Connection: keep-alive
  sockwrite -n amped.user $crlf
} 
on *:sockread:amped.user:{
  if ($sockerr > 0) {
    return
  } 
  else {
    :nextread
    sockread %amped.temp
    if ($sockbr == 0) {
      return
    }
    if (Profile not found. Invalid user ID. isin %amped.temp) {
      did -a lookup 35  [ Profile not found Invalid UserID ]
      unset %amped.*
      sockclose amped.user
    }
    if (Alias</td> isin %amped.temp) {
      sockread %amped.temp
      set %amped.alias $htmlfree(%amped.temp)
    }
    if (class="greysmall" bgcolor="#EEEEEE"> isin %amped.temp) {
      var %amped.temp = $replace(%amped.temp,  $+ $chr(59),$chr(255))
      set %amped.name $gettok($htmlfree(%amped.temp),1,255)
    }
    if (Full Name</td> isin %amped.temp) {
      sockread %amped.temp
      set %amped.name $htmlfree(%amped.temp)
    }
    if (Age</td> isin %amped.temp) {
      sockread %amped.temp | sockread %amped.temp
      set %amped.age $htmlfree(%amped.temp)
    }
    if (Location</td> isin %amped.temp) {
      sockread %amped.temp
      set %amped.location $htmlfree(%amped.temp)
    }
    if (Country</td> isin %amped.temp) {
      sockread %amped.temp
      set %amped.Country $htmlfree(%amped.temp)
    }
    if (Membership</td> isin %amped.temp) {
      sockread %amped.temp
      set %amped.Membership $htmlfree(%amped.temp)
    }
    if (class="greybold">Forum isin %amped.temp) {
      sockread %amped.temp
      if ($htmlfree(%amped.temp) isnum) {
        set %amped.posts $htmlfree(%amped.temp)
      }
      else {
        sockread %amped.temp
        set %amped.posts $htmlfree(%amped.temp)
      }
    }
    if (Amped Rating</td> isin %amped.temp) {
      sockread %amped.temp
      set %amped.rating $htmlfree(%amped.temp)
      did -a lookup 35 [ Amped Member Profiles ] $crlf
      did -a lookup 35 [ UserID : %amped.userid ] $crlf
      did -a lookup 35 [ Alias : %amped.alias ] $crlf
      did -a lookup 35 [ Name : $replace(%amped.name,&nbsp,$chr(32)) ] $crlf
      did -a lookup 35 [ Age : %amped.age ] $crlf
      did -a lookup 35 [ Location : %amped.location ] $crlf
      did -a lookup 35 [ Country : %amped.Country ] $crlf
      did -a lookup 35 [ Membership : %amped.Membership ] $crlf
      did -a lookup 35 [ Forum Posts : %amped.posts ] $crlf
      did -a lookup 35 [ Amped Rating : %amped.rating ] $crlf
      did -a lookup 35 [http://www.ampednews.com/?page=profile&id= $+ %amped.userid $+ ] $crlf $crlf
      unset %amped.*
      sockclose amped.user
    }
    else {
      goto nextread
    }
  }
}
