dialog rcon {
  title "Remote Server Control"
  size -1 -1 150 100
  option dbu
  text "Please enter your server info:", 1, 50 5 200 20


  edit %rcon.ip, 2, 50 20 45 10,autohs
  box "Server IP:", 3, 47 13 50 20

  edit %rcon.port, 7, 50 40 25 10,autohs
  box "Server Port:", 8, 47 33 30 20

  edit %rcon.pass, 9, 50 60 35 10,autohs
  box "Server RCON Password:", 10, 47 53 40 20

  button "Save + Close", 4, 2 3 40 10
  button "Cancel", 6, 2 15 40 10,cancel
}
on *:dialog:rcon:sclick:4: {
  set %rcon.ip $did(2).text
  set %rcon.port $did(7).text
  set %rcon.pass $did(9).text
  dialog -x rcon
}



on *:load: {
  dialog -m rcon rcon
}

on *:udpread:rconsocket2:{
  sockread %rcon.chall
  aline @rcon %rcon.chall
  sockclose rconsocket2
}


on *:udpread:rconsocket:{
  window -e @rcon /rcon 
  if ($sockerr > 0) { aline @rcon uh oh, socket error }
  if ((%rcon.cmd == $null) && (%rcon.chall.use == $null) && (%rcon.next == $null)) { aline @rcon Must specify server command | sockclose rconsocket }
  if (%rcon.chall.use != $null) {
    sockread %rcon.chall 
    set %rcon.challenge $right(%rcon.chall,9)
    aline @rcon Server challenge updated
    unset %rcon.chall 
    unset %rcon.chall.use 
  }
  if (%rcon.cmd != $null) {
    :nextudp
    sockread %rcon.temp
    if ((%rcon.temp == $null) && (%rcon.next == $null)) { aline @rcon Server could not respond | sockclose rconsocket }
    if ((%rcon.temp == $null) && (%rcon.next != $null)) { unset %rcon.next }
    elseif (%rcon.temp != $null) {
      set %rcon.return $remove(%rcon.temp,l,9)
      aline @rcon %rcon.return
      unset %rcon.temp
      unset %rcon.return
      unset %rcon.cmd
      set %rcon.next 1
      goto nextudp
    } 
  }
  sockclose rconsocket
}

alias rcon { 
  if ($1 == setup) {
    dialog -m rcon rcon
    halt
  }
  if ($1 ==  challenge) {
    set %rcon.chall.use 1
    sockudp -k rconsocket %rcon.ip %rcon.port challenge rcon
  }
  else { 
    set %rcon.cmd $1-
    sockudp -k rconsocket %rcon.ip %rcon.port rcon %rcon.challenge " $+ %rcon.pass $+ " %rcon.cmd
  }
}
